# HierarchicalUtils
HierarchicalUtils.jl is a package providing abstract functionality over hierarchical structures.

[![License](https://img.shields.io/badge/License-MIT-blue.svg)](https://github.com/CTUAvastLab/HierarchicalUtils.jl/blob/master/LICENSE)
[![Build Status](https://github.com/CTUAvastLab/HierarchicalUtils.jl/workflows/CI/badge.svg)](https://github.com/CTUAvastLab/HierarchicalUtils.jl/actions?query=workflow%3ACI)
[![Coverage Status](https://coveralls.io/repos/github/CTUAvastLab/HierarchicalUtils.jl/badge.svg?branch=master)](https://coveralls.io/github/CTUAvastLab/HierarchicalUtils.jl?branch=master)
[![codecov.io](http://codecov.io/github/CTUAvastLab/HierarchicalUtils.jl/coverage.svg?branch=master)](http://codecov.io/github/CTUAvastLab/HierarchicalUtils.jl?branch=master)

## How it works

For specific examples, see the following Jupyter notebooks:

Basics: [Expression tree representation](https://github.com/CTUAvastLab/HierarchicalUtils.jl/blob/master/examples/expression_tree.ipynb)

Advanced applications: [BSON representation visualization](https://github.com/CTUAvastLab/HierarchicalUtils.jl/blob/master/examples/visualizations.ipynb), 
[Integration with Mill.jl](https://github.com/CTUAvastLab/HierarchicalUtils.jl/blob/master/examples/mill_integration.ipynb)

## Examples of packages using `HierarchicalUtils.jl`

* [`Mill.jl`](https://github.com/CTUAvastLab/Mill.jl)
* [`JsonGrinder.jl`](https://github.com/CTUAvastLab/JsonGrinder.jl)
